Attribute VB_Name = "mMain"
Option Explicit
Declare Function GetDefaultCommConfig Lib "kernel32" Alias "GetDefaultCommConfigA" (ByVal lpszName As String, lpCC As COMMCONFIG, lpdwSize As Long) As Long


Type DCB
        DCBlength As Long
        BaudRate As Long
        fBitFields As Long
        wReserved As Integer
        XonLim As Integer
        XoffLim As Integer
        ByteSize As Byte
        Parity As Byte
        StopBits As Byte
        XonChar As Byte
        XoffChar As Byte
        ErrorChar As Byte
        EofChar As Byte
        EvtChar As Byte
        wReserved1 As Integer
End Type

Type COMMCONFIG
    dwSize As Long
    wVersion As Integer
    wReserved As Integer
    dcbx As DCB
    dwProviderSubType As Long
    dwProviderOffset As Long
    dwProviderSize As Long
    wcProviderData As Byte
End Type

Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Enum eMode
    [eAdd] = 0
    [eEdit]
    [eDelete]
End Enum
Public Const QuestionAdd = "Would you add another sequence?"
Public mMode            As eMode

Type tStep
    
    StepNumber  As Integer
    Comment As String * 15
    Pin(1 To 18) As Single
End Type

Type tSeq
    ID As Integer
    SeqList() As tStep
    iStep As Integer
    StartPointer As Integer
    EndPointer As Integer
    loopNbr As Integer
    SSCtime As Integer
    Name As String * 15
    Description As String * 15
End Type

Public Type tSequence
    iSeq As Integer
    Sequences() As tSeq
    
End Type

Public Sequence As tSequence
Public CurStep As Integer
Public CurSeq As Integer
Public CurLeg As Integer

Public Const cstLeg As Integer = 4
Public OffsetServo(31) As Integer
Public OffsetX(6) As Integer
Public OffsetY(5) As Integer

Public Sub SaveData( _
           ByVal FileName As String _
           )
    
  Dim hFile As Long
  Dim i     As Long
  Dim j     As Long
  Dim k     As Long
    On Error Resume Next
    Call VBA.Kill(FileName)
    On Error GoTo 0
  
    hFile = VBA.FreeFile()
  
    With Sequence
        
        Open FileName For Binary Access Write As #hFile
        
            Put #hFile, , .iSeq
            
            If (.iSeq) Then
                For i = 1 To .iSeq
                    With .Sequences(i)
                        Put #hFile, , .ID
                        Put #hFile, , .StartPointer
                        Put #hFile, , .EndPointer
                        Put #hFile, , .loopNbr
                        Put #hFile, , .iStep
                        Put #hFile, , .SSCtime
                        Put #hFile, , .Name
                        Put #hFile, , .Description
                        If (.iStep) Then
                            
                                For j = 1 To .iStep
                                    With .SeqList(j)
                                        Put #hFile, , .StepNumber
                                        Put #hFile, , .Comment
                                        'If (.StepNumber) Then
                                            For k = 1 To 18
                                                Put #hFile, , .Pin(k)
                                            Next
                                        'End If
                                    End With
                                Next
                            
                        End If
                    End With
                Next i
            End If
          
        Close #hFile
    End With
End Sub

Public Sub LoadData( _
           ByVal FileName As String _
           )

  Dim hFile As Long
  Dim i     As Long
  Dim j     As Long
  Dim k     As Long

    hFile = VBA.FreeFile()

    With Sequence

        Open FileName For Binary Access Read As #hFile

            Get #hFile, , .iSeq
            ReDim .Sequences(0 To .iSeq)
            If .iSeq Then Form1.cmdAction(9).Enabled = True
            For i = 1 To .iSeq
                With .Sequences(i)
                        Get #hFile, , .ID
                        Get #hFile, , .StartPointer
                        Get #hFile, , .EndPointer
                        Get #hFile, , .loopNbr
                        Get #hFile, , .iStep
                        Get #hFile, , .SSCtime
                        Get #hFile, , .Name
                        Get #hFile, , .Description
                        ReDim .SeqList(0 To .iStep)
                        
                        For j = 1 To .iStep
                            With .SeqList(j)
                                Get hFile, , .StepNumber
                                Get #hFile, , .Comment
                                For k = 1 To 18
                                    Get #hFile, , .Pin(k)
                                Next
                                
                            End With
                        Next
                End With
            Next i
        Close #hFile
    End With
End Sub
Public Sub Insert(nIdx As Integer)
    
  Dim i As Long
  
   If (nIdx > 0) Then
        With Sequence
            .Sequences(CurSeq).iStep = .Sequences(CurSeq).iStep + 1
            ReDim Preserve .Sequences(CurSeq).SeqList(0 To .Sequences(CurSeq).iStep)
            For i = .Sequences(CurSeq).iStep To nIdx Step -1
                .Sequences(CurSeq).SeqList(i) = .Sequences(CurSeq).SeqList(i - 1)
                 
            Next

            '.Sequences(CurSeq).SeqList(nIdx) = NewStep
        End With
    End If
End Sub
Public Sub DeleteStep(nIdx As Integer)
    'bugbug
  Dim i As Long
  
   If (nIdx > 0) Then
        With Sequence
        
                    For i = nIdx To .Sequences(CurSeq).iStep - 1
                        .Sequences(CurSeq).SeqList(nIdx) = .Sequences(CurSeq).SeqList(i + 1)
                    Next i
                    .Sequences(CurSeq).iStep = .Sequences(CurSeq).iStep - 1
                    ReDim Preserve .Sequences(CurSeq).SeqList(0 To .Sequences(CurSeq).iStep)
        End With
    End If
End Sub
Public Sub SelectionDelete(nIdx As Integer)
    
  Dim i As Long
  
   If (nIdx > 0) Then
        With Sequence
        
                    For i = nIdx To .iSeq - 1
                        .Sequences(i) = .Sequences(i + 1)
                    Next i
                    .iSeq = .iSeq - 1
                    ReDim Preserve .Sequences(0 To .iSeq)
        End With
    End If
End Sub


'=====================
'==== Fill combo =====
'=====================


Public Sub FillCbo(ByRef cb As ComboBox)
    Dim i As Integer
    Dim j As Integer
    Dim bFound As Boolean
        cb.Clear
        If Sequence.iSeq >= 1 Then
        For i = 1 To UBound(Sequence.Sequences)
            bFound = False
                For j = 0 To cb.ListCount - 1
                If cb.List(j) = Trim(Sequence.Sequences(i).Name) Then bFound = True
            Next
            If Not bFound Then cb.AddItem Trim(Sequence.Sequences(i).Name)
        Next
        If cb.ListCount <> 0 Then
            cb.ListIndex = 0
        End If
        Form1.HScroll5.Value = 1
        End If
        
End Sub

Public Function EnumSerPorts(port As Integer) As Long
'returns non-zero value if the port exists
        Dim cc As COMMCONFIG, ccsize As Long
        ccsize = LenB(cc)     'gets the size of COMMCONFIG structure
        EnumSerPorts = GetDefaultCommConfig("COM" + Trim(Str(port)) + Chr(0), cc, ccsize)
End Function
